<?php
namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DataSource\DataSet;

class PratoController
{

    protected $entityManager;

    public function __construct($novoCodigo, $entityManager)
    {
        $this->novoCodigo = $novoCodigo;
        $this->entityManager = $entityManager;
    }

    public function getPratos($request, $response)
    {
        $sql = "SELECT TO_NUMBER(NRORDPRATCAR) AS NRORDPRATCAR, CASE WHEN IDCONCNFMES = 'S' AND IDRESERVAMYMENU = 'S' THEN 1 WHEN IDRESERVAMYMENU = 'S' THEN 2 ELSE 3 END AS SESSAO_LAYOUT, CDTIPOPRAT, NMTIPOPRAT, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, NMPRATO, DSPRATO, VRAVALIACAO, QTAVALIACAO, IDGLUTEN, IDLACTOSE, CALORIAS_KCAL_ROUND, NRFOTOPRATOBLOB, NRCARDAPIO, IDRESERVAMYMENU FROM(SELECT P.CDTIPOPRAT, P.NMTIPOPRAT,P.NRSEQPRATCAR, NRORDPRATCAR, P.IDCONCNFMES, P.CDFILAUXPRAT, P.CDPRATO, P.NMPRATO, P.DSPRATO, P.VRAVALIACAO, P.QTAVALIACAO, P.IDGLUTEN, P.IDLACTOSE, TO_CHAR(P.CALORIAS_KCAL, '9999990.99') AS CALORIAS_KCAL_ROUND, NRFOTOPRATOBLOB, P.URL_FOTOPRATO,P.NRCARDAPIO, P.IDRESERVAMYMENU FROM TABLE(PRATOS_MYMENU(NULL, NULL, :CDFILIAL, :CDSERVFILI, 'N', NULL, :DTCARDAPIO, :NRORG)) P ) ORDER BY SESSAO_LAYOUT ASC, TO_NUMBER(NRORDPRATCAR)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        $params = [
            'NRORG' => $row['NRORG'], 
            'CDFILIAL' => $row['CDFILIAL'], 
            'CDSERVFILI' => $row['CDSERVFILI'], 
            'DTCARDAPIO' => $row['DTCARDAPIO']
        ];

        $statement = $conn->prepare($sql);
        $statement->execute($params);

        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('prato', $result));
    }

    public function insertReservaPrato($request, $response)
    {
        
        $sql = "INSERT INTO AVALIACAOPRATO (NRAVALIACAOPRATO, CDFILIAL, CDSERVFILI, NRCARDAPIO, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT, DTCARDAPIO, NRORG, IDCONSUMO, NMUSUARIO, HRCONSUMO, DSCONSUMO, NRLOCALPESQ) VALUES (:NRAVALIACAOPRATO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :NRSEQPRATCAR, :CDFILAUXPRAT, :CDPRATO, :CDTIPOPRAT, :DTCARDAPIO, :NRORG, :IDCONSUMO, :NMUSUARIO, :HRCONSUMO, :DSCONSUMO, :NRLOCALPESQ)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $CDFILIAL = $row["CDFILIAL"];
        $CDSERVFILI = $row["CDSERVFILI"];
        $DTCARDAPIO = $row["DTCARDAPIO"];
        $NRORG = $row["NRORG"];
        $NMUSUARIO = $row["NMUSUARIO"];
        $HRCONSUMO = $row["HRCONSUMO"];
        $DSCONSUMO = $row["DSCONSUMO"];
        $NRLOCALPESQ = $row["NRLOCALPESQ"];
        $plates = $row["plates"];
        
        foreach($plates as $plate){
                    
            $NRAVALIACAOPRATO = $this
                            ->novoCodigo
                            ->getCodeByTableName('AVALIACAOPRATO', $row['NRORG'], 1, 10, false);
            $params = [
                "NRAVALIACAOPRATO" => $NRAVALIACAOPRATO ,
                "CDFILIAL" => $CDFILIAL,
                "CDSERVFILI" => $CDSERVFILI,
                "NRCARDAPIO" => $plate["NRCARDAPIO"],
                "NRSEQPRATCAR" => $plate["NRSEQPRATCAR"],
                "CDFILAUXPRAT" => $plate["CDFILAUXPRAT"],
                "CDPRATO" => $plate["CDPRATO"],
                "CDTIPOPRAT" => $plate["CDTIPOPRAT"],
                "DTCARDAPIO" => $DTCARDAPIO,
                "NRORG" => $NRORG,
                "IDCONSUMO" => "S",
                "NMUSUARIO" => $NMUSUARIO,
                "HRCONSUMO" => $HRCONSUMO,
                "DSCONSUMO" => $DSCONSUMO,
                "NRLOCALPESQ" => $NRLOCALPESQ
            ];

            $statement = $conn->prepare($sql);
            $statement->execute($params);
        }


    }
    
    public function ratePlate($request, $response)
    {
        $sql = "INSERT INTO AVALIACAOPRATO (NRAVALIACAOPRATO, IDCONSUMO, CDFILIAL, CDSERVFILI, NRCARDAPIO, DTCARDAPIO, NRORG, NRLOCALPESQ, CDPRATO, CDFILAUXPRAT, VRAVALIACAOPRATO) VALUES (:NRAVALIACAOPRATO, :IDCONSUMO, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :DTCARDAPIO, :NRORG,:NRLOCALPESQ, :CDPRATO, :CDFILAUXPRAT, :VRAVALIACAOPRATO)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $NRAVALIACAOPRATO = $this
                        ->novoCodigo
                        ->getCodeByTableName('AVALIACAOPRATO', $row['NRORG'], 1, 10, false);
                        
        $params = [
            'NRAVALIACAOPRATO' => $NRAVALIACAOPRATO,
            'IDCONSUMO' => "N",
            'CDFILIAL' => $row['CDFILIAL'],
            'CDSERVFILI' => $row['CDSERVFILI'],
            'NRCARDAPIO' => $row['NRCARDAPIO'],
            'DTCARDAPIO' => $row['DTCARDAPIO'],
            'NRORG' => $row['NRORG'],
            'NRLOCALPESQ' => $row['NRLOCALPESQ'],
            'CDPRATO' => $row['CDPRATO'],
            'CDFILAUXPRAT' => $row['CDFILAUXPRAT'],
            'VRAVALIACAOPRATO' => $row['rateValue']
        ];
        

        $statement = $conn->prepare($sql);

        $statement->execute($params);

    }
    
    public function getNutrientes($request, $response){

        $sql = "SELECT G.CDGRUPNUTR, G.NMGRUPNUTR, N.CDNUTRIENTE, N.NMNUTRIENTE, N.NMREDUZIDO, TO_CHAR(NUT.QTNUTRIENTE, '9999990.9999') AS QTNUTRIENTE , N.SGUNIDADE FROM ( SELECT CDNUTRCALC, SUM(P.QTNUTRCALC) AS QTNUTRIENTE FROM TABLE ( NUTRIENTE_PRATO_PME(:CDFILCENTPME,:CDTIPOCARD,:CDFILIAL,:CDSERVFILI,NULL,'S',:CDPRATO,:CDPRATO) ) P WHERE :IDTIPOSERV = 'M' GROUP BY CDNUTRCALC UNION ALL SELECT CDNUTRCALC, SUM(P.QTNUTRCALC) AS QTNUTRIENTE FROM TABLE ( NUTRIENTE_PRATO(:CDFILIAL,:CDSERVFILI,NULL,'S',:CDPRATO,:CDPRATO) ) P WHERE :IDTIPOSERV <> 'M' GROUP BY CDNUTRCALC ) NUT INNER JOIN NUTRIENTE N ON NUT.CDNUTRCALC = N.CDNUTRIENTE AND NRORG = :NRORG INNER JOIN GRUPNUTR G ON G.CDGRUPNUTR = N.CDGRUPNUTR ORDER BY G.CDGRUPNUTR, N.CDNUTRIENTE";

        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $params = array(
            "CDPRATO" => $row['CDPRATO'],
            "NRORG" => $row['NRORG'],
            "CDSERVFILI" => $row['CDSERVFILI'],
            "IDTIPOSERV" => $row['IDTIPOSERV'],
            "CDFILIAL" => $row['CDFILIAL'],
            "CDFILCENTPME" => null,
            "CDTIPOCARD" => null
        );
        
        $statement = $conn->prepare($sql);
        $statement->execute($params);

        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('nutrientes', $result));
    }

    protected function executeInsertSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }
}